#!/usr/bin/perl

#Autor: Carles Pina i Estany <carles@pinux.info>
#Data: Febrero 2004
#Llicncia: GPL v. 2.0 o posterior
#Ms informaci: http://pinux.info/utils/index.html#backupcd


use autouse 'File::Basename' => qw(fileparse);

if ($ARGV[0] eq "--help" || $ARGV[0] eq "-help") {
	print "$0 [num_megues] [desti]\n\n";
	exit 1;
}

if ($ARGV[0] ne "") {
	$capacitat_cd=$ARGV[0]*1024*1024;
}
else {
	$capacitat_cd=650*1024*1024;
}

if ($ARGV[1] ne "") {
	print "Directori dest: $ARGV[1]\n";
	$desti=$ARGV[1];
}
else {
	$desti=".",
}

if ($ARGV[1] eq "simula") {
	$simulacio=1;
}
else {
	$simulacio=0;
}


$acumulat=0;
$num_fitxer="01";

print "Comeno CD 1\n";

if ($simulacio) {
	$obrir="/dev/null";
}
else {
	$obrir="$desti/$num_fitxer.cd";
}

open (FITXER,">$obrir") or die "No puc obrir $obrir";
while (<STDIN>) {
	chomp;
	
	($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks) = stat ("$_");
	if ($acumulat+$size > $capacitat_cd) {
		close FITXER;
		$num_fitxer++;
		$num_fitxer=sprintf("%02s",$num_fitxer);
		if ($simulacio) {
			$obrir="/dev/null";
		}
		else {
			$obrir="$desti/$num_fitxer.cd";
		}

		open (FITXER,">$obrir") or die "No puc obrir $obrir";
		
		print "Capacitat anterior: ".&bytes_a_mb($acumulat).". Comeno CD: $num_fitxer\n";
		$acumulat=0;
	}

	#$graft=&separar ($_);
	($basename,$dirname) = fileparse($_);
	print FITXER "$dirname=$_\n";
	$acumulat+=$size;
}
print "Capacitat $num_fitxer: ".&bytes_a_mb($acumulat)."MB\n";
close FITXER;
exit 0;

sub bytes_a_mb {
	$bytes=shift(@_);

	return (sprintf("%2.2f",$bytes/1024/1024));
}

sub separar {
	$fitxer=shift(@_);


}

